/*
 *	Plugin Console for debugging session.
 *	Copyright (C) 2011 CEDAR Solutions s.r.l.
 *
 *	Authors:
 *		Marco Giammarini <m.giammarini@warcomeb.it>
 */

#include "StdAfx.h"
#include ".\pluginconsole.h"

PluginConsole * PluginConsole::_instance = 0;
int PluginConsole::_yposition = 0;

PluginConsole *
PluginConsole::getInstance ()
{
    return _instance ? _instance : (_instance = new PluginConsole);
}

PluginConsole::PluginConsole(void)
{
	_consoleValid = AllocConsole();

	if(_consoleValid)
	{
		SetConsoleTitle("USBStepMotorCtrl Plugin Console");

		hhwnd   = GetConsoleWindow();
		hhandle = GetStdHandle(STD_OUTPUT_HANDLE);
	}
}

void
PluginConsole::printMessage (const char * msg)
{
	DWORD NumberOfCharsWritten;
	COORD dwCursorPosition;
         
	if(_consoleValid)
	{
		dwCursorPosition.X = 0;
		dwCursorPosition.Y = _yposition;
		SetConsoleCursorPosition(hhandle,dwCursorPosition);
		WriteConsole(hhandle,msg,strlen(msg),&NumberOfCharsWritten,NULL);
 
		_yposition++;
	}
}
