/*
 *	Plugin main class
 *	Copyright (C) 2011 CEDAR Solutions s.r.l.
 *
 *	Authors:
 *		Marco Giammarini <m.giammarini@warcomeb.it>
 */

#include "StdAfx.h"

#include "TrajectoryControl.h"
#include "Mach4View.h"
#include "Engine.h"
#include "resource.h"
#include "rs274ngc.h"
#include "XMLProfile.h"

#include ".\usbplugin.h"
#include ".\pluginconsole.h"

extern TrajectoryControl  *MainPlanner; // used for most planner funcitons and program control 
extern CMach4View         *MachView;    // used for most framework and configuration calls. 
extern TrajBuffer         *Engine;      // Ring0 memory for printer port control and other device syncronisation
extern setup              *_setup;      // Trajectory planners setup block. Always in effect


USBPlugin::USBPlugin (void)
{
	/* The device is not connect! */
	_connected = true;

	/* Set the max speeds of Mach3 for this device... TODO: TEST IT */
//	for( int x = 0; x < 7; x++ )
//		MainPlanner->ExternalPulseRates[x] = 75000;
}

USBPlugin::~USBPlugin (void)
{
}

bool USBPlugin::connect (void)
{

	return _connected;
}

void USBPlugin::open (void)
{

}

void USBPlugin::update (void)
{
	if (Engine->TrajHead == Engine->TrajIndex)
	{
//		PluginConsole::getInstance()->printMessage("Same positions...");
		return;
	}
	else
	{
		Engine->TrajIndex++;
		Engine->TrajIndex &= 0xFFF;
//		PluginConsole::getInstance()->printMessage("New positions...");
	}
}
